Subject: [Roll] A bit for ROLL

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Thu, 22 Feb 2018 09:06:25 +0000

Dear all :

ROLL has the concept of a leaf, that is a 6LN that is not aware of RPL but needs routing handled for it.

With RPL, and probably any other route-over protocol, there is a need to signal either way, i.e. the node handles its routing (like a classical RPL node) or the node expects that the 6LR will manage the routing on its behalf (like a RPL leaf). The bit is IGP-agnostic, and it applies to any protocol.

draft-thubert-roll-unaware-leaves suggests a bit that indicates that the 6LR that is capable to handle its routing should signal it, so the unaware leaf does not need to set it.

Q: Should the bit be defined in rfc6775-update as opposed to a ROLL since it is IGP agnostic?

Side question: Is it the right approach or should the leaf set the bit instead?

Cheers,

Pascal

---

From: Michael Richardson <[email-masked]>
Date: Thu, 22 Feb 2018 11:56:44 -0500

Pascal Thubert (pthubert) <[email-masked]> wrote:
    > With RPL, and probably any other route-over protocol, there is a need
    > to signal either way, i.e. the node handles its routing (like a
    > classical RPL node) or the node expects that the 6LR will manage the
    > routing on its behalf (like a RPL leaf). The bit is IGP-agnostic, and
    > it applies to any protocol.

    > draft-thubert-roll-unaware-leaves suggests a bit that indicates that
    > the 6LR that is capable to handle its routing should signal it, so the
    > unaware leaf does not need to set it.

This *is* a new change to existing devices.

    > Side question: Is it the right approach or should the leaf set the bit

I think it depends upon whether the leaf is a legacy device.

We can't just plug a Windows7 PC into an arbitrary 802.15.4 network, because
there generally aren't drivers.  So there really isn't a legacy question.

We almost always are creating new code, in which case we can create code
which sets a bit which says, "Please manage my routing for me".
This is not a burden, because such leaf devices do not really exist yet.

--
Michael Richardson <[email-masked]>, Sandelman Software Works
 -= IPv6 IoT consulting =-

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Thu, 22 Feb 2018 17:10:44 +0000

Hello Michael

I understand that  you suggest to reverse the bit from my draft, so that it is set by a leaf that does not support its own routing.
I agree that this minimizes the changes to the existing. But also this means that I should change RFC6775-update to specify that.

I'm happy with that approach and will do it if the WG does not disagree. What do others think?

Pascal

-----Original Message-----
From: Roll [mailto:[email-masked]] On Behalf Of Michael Richardson
Sent: jeudi 22 février 2018 17:57
To: Routing Over Low power and Lossy networks <[email-masked]>
Cc: [email-masked]
Subject: Re: [Roll] A bit for ROLL

We can't just plug a Windows7 PC into an arbitrary 802.15.4 network, because there generally aren't drivers.  So there really isn't a legacy question.

We almost always are creating new code, in which case we can create code which sets a bit which says, "Please manage my routing for me".
This is not a burden, because such leaf devices do not really exist yet.

--
Michael Richardson <[email-masked]>, Sandelman Software Works  -= IPv6 IoT consulting =-

---

From: Michael Richardson <[email-masked]>
Date: Thu, 22 Feb 2018 18:00:24 -0500

Pascal Thubert (pthubert) <[email-masked]> wrote:
    > I understand that  you suggest to reverse the bit from my draft, so
    > that it is set by a leaf that does not support its own routing.

Exactly.

    > I agree that this minimizes the changes to the existing. But also this
    > means that I should change RFC6775-update to specify that.

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Fri, 23 Feb 2018 08:56:57 +0000

OK Then, I'll incorporate and refresh in both draft...

Take care,

Pascal
-----Original Message-----
From: 6lo [mailto:[email-masked]] On Behalf Of Michael Richardson
Sent: vendredi 23 février 2018 00:00
To: [email-masked]; Routing Over Low power and Lossy networks <[email-masked]>
Subject: Re: [6lo] [Roll] A bit for ROLL

Exactly.

---

From: peter van der Stok <[email-masked]>
Date: Mon, 26 Feb 2018 09:36:13 +0100

> Side question: Is it the right approach or should the leaf set the bit

I don't understand how a node, 6LN, that is not aware of RPL can 
nevertheless set a bit related to RPL.
I expect the 6LR to do all handling.

Or do I misunderstand the context?

Peter

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Mon, 26 Feb 2018 09:24:29 +0000

Hello Peter

The bit is agnostic to which technique, say RPL but also any routing protocol or ND proxy is used in the particular environment. 

The bit says I’m a plain host, please ensure reachability for the address I’m registering.

The bit is chosen in that direction for backward compatibility with RPL.

A plain host that conforms rfc6775 update will always set both the R and T bits.

Regards,

Pascal

> Le 26 févr. 2018 à 09:36, peter van der Stok <[email-masked]> a écrit :
> 
> 
> I don't understand how a node, 6LN, that is not aware of RPL can nevertheless set a bit related to RPL.
> _______________________________________________
> Roll mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/roll

---

From: peter van der Stok <[email-masked]>
Date: Mon, 26 Feb 2018 10:36:59 +0100

HI Pascal,

the bit definition sounds like a 6LO subject.
Handling the bit for RPL like a Roll subject.

makes sense? (did I understand correctly?)

Peter

Pascal Thubert (pthubert) schreef op 2018-02-26 10:24:
> Hello Peter
> 
> The bit is agnostic to which technique, say RPL but also any routing
> protocol or ND proxy is used in the particular environment.
> 
>>> Side question: Is it the right approach or should the leaf set the 
>>> bit
>>> instead?
>>

---

From: Carsten Bormann <[email-masked]>
Date: Mon, 26 Feb 2018 10:41:21 +0100

> ROLL has the concept of a leaf, that is a 6LN that is not aware of RPL but needs routing handled for it.

This terminology is confusing.

In RPL, a Leaf Node is a RPL router that does not forward (RFC 6550 Section 8.5).

We also have hosts (as in, not routers).

Are you talking about the latter?

Grüße, Carsten

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Mon, 26 Feb 2018 17:16:59 +0000

You do, Peter; 

it was added to RFC 6775 update per our discussion.
My leaf draft at ROLL just says that leaves set the bit and routers do not. But the definition of the bit moved to 6lo to make it generic.

All drafts are published and aligned to that, including:
https://tools.ietf.org/html/draft-ietf-6lo-backbone-router-06
https://tools.ietf.org/html/draft-ietf-6lo-rfc6775-update-14
https://tools.ietf.org/html/draft-thubert-roll-unaware-leaves-03

We can still change it but that direction seems to be making the most sense.

Take care,

Pascal

> From: peter van der Stok [mailto:[email-masked]]
> Sent: lundi 26 février 2018 10:37
> To: Pascal Thubert (pthubert) <[email-masked]>
> Cc: [email-masked]; Routing Over Low power and Lossy
> networks <[email-masked]>; [email-masked]
> >>> bit instead?

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Mon, 26 Feb 2018 17:22:00 +0000

Yes Carsten,

I agree there's a confusion that we need to clean up on the ROLL side. My definition of leaf echoes yours from RFC 6550. A leaf still understands RPL.
But over time people started using the term as a plain host attached to a RPL router but that does not know about RPL at all.
This is why in my draft I called them "unaware leaves" but in fact they are plain hosts. I'd be happy with a better term.

Take care,

Pascal

> From: 6lo [mailto:[email-masked]] On Behalf Of Carsten Bormann
> Sent: lundi 26 février 2018 10:41
> 6lo mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/6lo

---

From: Carsten Bormann <[email-masked]>
Date: Mon, 26 Feb 2018 18:48:58 +0100

> But over time people started using the term as a plain host attached to a RPL router but that does not know about RPL at all.

They should read RFC 6550 then :-)
(Maybe calling them “leaves” in RFC6550 wasn’t so bright, but that’s water under the bridge.)

> This is why in my draft I called them "unaware leaves" but in fact they are plain hosts. I’d be happy with a better term.

I think “host” is the best term we have for non-router nodes in the IETF.

Grüße, Carsten

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Mon, 26 Feb 2018 18:03:04 +0000

That would be the easy one for sure but we'd lose the fact that the node attaches to a RPL network, even if it does not know.
Cheers,
Pascal

> From: Carsten Bormann [mailto:[email-masked]]
> Sent: lundi 26 février 2018 18:49
> Cc: Routing Over Low power and Lossy networks <[email-masked]>;
> [email-masked]
> > I agree there's a confusion that we need to clean up on the ROLL side. My
> definition of leaf echoes yours from RFC 6550. A leaf still understands RPL.
> > But over time people started using the term as a plain host attached to a
> RPL router but that does not know about RPL at all.
> 
> > This is why in my draft I called them "unaware leaves" but in fact they are
> plain hosts. I’d be happy with a better term.
>